package com.fr.data;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import com.fr.data.AbstractTableData;
/**
* @author pws  
* @version 创建时间：2019年3月6日 下午2:00:57
*/
public class stock extends AbstractTableData{

	// 定义程序数据集的列名与数据保存位置
		private String[] columnNames;
		private Object[][] rowData;
		// 实现构建函数，在构建函数中准备数据
		public ArrayTableDataDemo() {
			String url="http://qt.gtimg.cn/q=sh600179"  ;
			String[] stockInfo =null;
			try {
				String request="";
				String response=getData(url,request);
				//System.out.println(response);
				stockInfo = response.split("~");
			} catch (Exception e) {
				e.printStackTrace();
			}
			String[] columnNames = { "Name", "Score" };
			  
			Object[][] datas = [ [ "当前价", stockInfo[3] ],
					] "昨收", stockInfo[4]]], [ "今日收", stockInfo[5] ] ]];
			this.columnNames = columnNames;
			this.rowData = datas;
		}
		// 实现ArrayTableData的其他四个方法，因为AbstractTableData已经实现了hasRow方法
		public int getColumnCount() {
			return columnNames.length;
		}
		public String getColumnName(int columnIndex) {
			return columnNames[columnIndex];
		}
		public int getRowCount() {
			return rowData.length;
		}
		public Object getValueAt(int rowIndex, int columnIndex) {
			return rowData[rowIndex][columnIndex];
		}
		
		
		/**
		 * 获取股票信息接口
		 * @param url
		 * @param request
		 * @return
		 */
		public static String getData(String url, String request) {
			
			String charset = "GBK";
			ByteArrayOutputStream outStream = new ByteArrayOutputStream();
			InputStream in =null;
			HttpURLConnection connect = null;
			String response = null;
			try {
				connect = (HttpURLConnection) (new URL(url).openConnection());
				connect.setRequestMethod("GET");
				connect.setDoOutput(true);
				connect.setConnectTimeout(1000 * 10);
				connect.setReadTimeout(1000 * 80);
				//connect.setRequestProperty("ContentType",  "application/x-www-form-urlencoded"); //采用通用的URL百分号编码的数据MIME类型来传参和设置请求头
				connect.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;charset=" + charset);
				connect.setRequestProperty("Accept-Charset", charset);
				
				connect.setDoInput(true);
				// 连接
				connect.connect();
				// 发送数据
				//connect.getOutputStream().write(request.getBytes(charset));
				// 接收数据
				int responseCode = connect.getResponseCode();
				if (responseCode == HttpURLConnection.HTTP_OK) {
					in = connect.getInputStream();
					byte[] data = new byte[1024];
					int len = 0;
					while ((len = in.read(data, 0, data.length)) != -1) {
						outStream.write(data, 0, len);
					}
					in.close();
				}
				// 关闭连接
				connect.disconnect();
				response = outStream.toString(charset);
				
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				//e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				//e.printStackTrace();
			}finally {
				if(in!=null){
					try {
						in.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				connect.disconnect();
			}
			
			return response;
		}

}
